$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZCSET                                    01/12/97  +
$REM + LU                                                            +
$REM + PURPOSE:  INCLUDE SIMULTANEOUS COMPUTATIONS FOR 'C' MODEL     +
$REM +---------------------------------------------------------------+

$IF(NC<>0)
$IF(NCL=NC)
  $SAVC=-1
  $LDC=-1
  $LCD=-1
$ELSE
  $SAVC=-1
  $IF(ISNC=1) $SAVC=0
  $IF(ISNC>1) $SAVC=1
  $IF(LDC<0)
    $LCD=-1
    $IF(KD<1)
    $ELSE
      $IF(KDC<1)
        $IF(ISNC=0)
          $SAVC=0
          $ISNC=1
          ISNC=$ISNC
        $ENDIF
      $ENDIF
    $ENDIF
  $ELSE
    $LCD=KD
    $IF(KDC>LDC)
      $IF(LCD>LDC) $LCD=LDC
    $ENDIF
    $IF(SAVC<LCD) $SAVC=LCD
    $SUBST('UC$(LCD)F02')
    $IF(LCD=2)
      $IF(JACC='S')
        $IW='IW'
        $IBG='IBG'
        $JBG='JBG'
        $ADD(INTEGER,'\$IBG($NF+1)\$JBG($MC)\$COLC($NF)\$IW(6*($NF))')
        $ADD(SINID)
          $SUBST('UYCMSC')
          $SUBST('UCSET6')
        $ENDADD
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(LCD<KDC)
    $IF(KD>1)
      $IF(JACC='S')
        $HELP
          MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
          APPROXIMATED FUNCTION HESSIAN MATRIX
        $CHECK(MHC,100,INT,1)
        $ADD(SINID)
          $SUBST('UCSET8')
        $ENDADD
        $HCS=HC
        $MHCS=MHC
      $ENDIF
    $ENDIF
  $ENDIF
$ENDIF
$ENDIF
