$INTERFACE UEDRD5                                             98/12/01
  $E1='E1'
  $E2R='E2R'
  $E2I='E2I'
  $IP1='IP1'
  $IP2='IP2'
  $DIME='11*($MEL)'
  $IF(MED<2) $DIME='11*($MEL)'
  $IF(MED=1)
    NAL=$NA
  $ENDIF
  $HELP
    STEP SELECTION
      1 - STEP SELECTION FROM LOCAL TRUNCATION ERROR
      2 - STEP SELECTION FROM PRESCRIBED MESH POINTS
  $CHECK(MED1,1,'1\2',4)
  $IF(MED1=1) $MED2=0
  $HELP
    NUMBER OF RESETING SOLUTIONS
      MED2=0 - NO RESETING SOLUTIONS
      MED2=1 - FIRST NE SOLUTIONS RESETTED
      MED2=2 - FIRST NE SOLUTIONS INTERPOLATED
  $CHECK(MED2,0,'0\1\2',4)
  $HELP
    MAXIMUM NUMBER OF INTEGRATION STEPS
  $CHECK(MSTP,100000,INT,3)
  $HELP
    TOLERANCE FOR THE JACOBIAN MATRIX RECOMPUTATION
  $CHECK(ALF3,'1.0$P-3',REAL,4)
  $HELP
    TOLERANCE FOR THE NEWTON METHOD TERMINATION
  $CHECK(BET3,'3.0$P-2',REAL,4)
  $HELP
    LOVER PARAMETER FOR STEPSIZE SELECTION
  $CHECK(TET1,'1.0$P 0',REAL,4)
  $HELP
    UPPER PARAMETER FOR STEPSIZE SELECTION
  $CHECK(TET2,'1.2$P 0',REAL,4)
  $HELP
    SAFETY FACTOR FOR STEPSIZE PREDICTION
  $CHECK(TET3,'0.9$P 0',REAL,4)
  $HELP
    INITIAL STEPSIZE
  $CHECK(HE,'0.0$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(HEMAX,'0.0$P 0',REAL,4)
  $HELP
    RELATIVE PRECISION
  $CHECK(TOLR,'1.0$P-6',REAL,3)
  $HELP
    ABSOLUTE PRECISION
  $CHECK(TOLA,'1.0$P-6',REAL,3)
  $HELP
    UPPER BOUND FOR SOLUTION NORM
  $CHECK(FMAX,'1.0$P 20',REAL,4)
  CALL UEDRD5(NA,NAL,NE,MEL,$MEL,KA,$AT,$AY,$YA,$YAO,$EF,$ES,$ED,$E1&
,$E2R,$E2I,$IP1,$IP2,$ETA0,$TET1,$TET2,$TET3,$ALF3,$BET3,TA,TAO&
,TAMAX,HE,HEO,HEMAX,FMAX,ERR,MED,MED1,MED2,NACC,NREJ,IER)
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$YAO($MEL)\$EF($MEL)&
  \$ES($DIME)\$ED($MEL*$MEL)\$E1($MEL,$MEL)\$E2R($MEL,$MEL)&
  \$E2I($MEL,$MEL)')
  $ADD(INTEGER,'\$IP1($MEL)\$IP2($MEL)')
$REM  $ADD(REAL,'\TA\TAO\TAMAX\HE\HEO\HEMAX\FMAX\ERR')
$REM  $ADD(INTEGER,'\NA\NAL\NE\MEL\KA\NACC\NREJ\IER')
  GOTO ($LET,$LED,$LEX) ISB+1
  $ADD(SINID)
    HEMAX=TAMAX-TA
  $ENDADD
  $ADD(INIT)
    NEDX='UEVDP5'
  $ENDADD
  $EXIT
