$INTERFACE UKLINM                                             98/12/01
  $HELP
    PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING SUBROUTINE
  $CHECK(EPS7,'1.0$P-7',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-9',REAL,4)
  $HELP
    PARAMETER CONTROLLING NUMBER OF COLUMNS TO BE TESTED
    ON INPUT INTO THE INITIAL BASIS:
     ABS(MLP)=1 - ALL COLUMNS ARE TESTED
     ABS(MLP)=2 - BASIS INCLUDES ONLY SLACKS AND ARTIFICIALS
          MLP>0 - ORIGINAL PROBLEM IS CONSIDERED
          MLP<0 - ARTIFICIAL BOX CONSTRAINTS ARE USED
  $CHECK(MLP,1,'-2\-1\1\2',4)
  MLP=ABS($MLP)
  $IF(MLP<0) $SUBST('UCSET9')
  $IF(KBF=0)
    CALL UXVINS(NF,0,IX)
  $ENDIF
  CALL UXVINS(NC,0,$LENR)
  CALL UKLINM(NF,NFL,NC,NCL,N,M,MROWS,MCOLS,NZ,NZA,NAU,NUQ,NEL,IBEG&
,IBGR,IENDLU,$RNR,$PRNR,$WN01,$WN02,$WR01,$WR02,$BCOL,$IX,$IC,$PINR&
,$INR,$PERMR,$IPRMC,$LENR,$PTR,$LENL,$PTL,$LENC,$PTC,$CNR,$ORDR&
,$ORDC,$ORDL,$RIGHT,$UP,$X,$G,$AU,$A,$AI,$CL,$CU,$XL,$XU,DEL1,DEL2,EPS7&
,EPS9,DMAX,GMAX,UMAX,MFP,MFP1,MLP,MLP1,NREF,KINP,LINP,MINP,KOLD,IER&
,ITERL)
  $ADD(REAL,'\$WR01($MCOLS)\$WR02($MCOLS)\$X($MCOLS)\$G($MCOLS)&
\$AU($NAU)\$A($NZA)\$AI($NZA)\$CL($MROWS)\$CU($MROWS)\$XL($MCOLS)&
\$XU($MCOLS)')
  $ADD(INTEGER,'\$RNR($NZA)\$PRNR($MCOLS+1)\$WN01($MCOLS)\$WN02($MCOLS)&
\$BCOL($MCOLS)\$IX($MCOLS)\$IC($MROWS)\$PINR($MCOLS+1)\$INR($NZA)&
\$PERMR($MROWS)\$IPRMC($MCOLS)\$LENR($MCOLS)\$PTR($MCOLS)&
\$LENL($MCOLS)\$PTL($MCOLS)\$LENC($MCOLS)\$PTC($MCOLS)\$CNR($NZ)&
\$ORDR($MCOLS)\$ORDC($MCOLS)\$ORDL($MCOLS)\$RIGHT($MCOLS)\$UP($MROWS)')
  $ADD(INTEGER,'\NUQ')
$REM  $ADD(INTEGER,'NF\NFL\NC\NCL\N\M\MROWS\MCOLS\NZ\NZA\NAU\NUP\NEL&
\IBEG\IBGR\IENDLU\MLP\MFP\MFP1\NREF\KINP\LINP\MINP\KOLD\IER\ITERL')
$REM  $ADD(REAL,'\DEL1\DEL2\EPS7\DMAX\GMAX\UMAX')
  $ADD(SINID)
    CALL UXVINS(MCOLS,1,BCOL)
  $ENDADD
  $ADD(INIT)
    NFXX='UKLINM'
  $ENDADD
  $EXIT
