$INTERFACE UYTRRG                                            16/12/01
  $HELP
    COMPUTATION OF THE GRADIENT NORM FOR TERMINATION CRITERIA:
      1 - MAXIMUM NORM OF THE MODIFIED REDUCED GRADIENT
      2 - EUCLIDEAN NORM OF THE REDUCED GRADIENT COMPUTED
          USING LAGRANGE MULTIPLIERS
      3 - MAXIMUM NORM OF THE PROJECTED GRADIENT COMPUTED
          USING LAGRANGE MULTIPLIERS
  $CHECK(KTERM,1,'1\2\3',4)
  $IF(KTERM=1)
    CALL UYTRBG(NF,N,MCL,$IX,$XN,$IC,$ICA,$CG,$CR,$CZ,$G,$GN,UMAX,GMAX&
,IOLD)
  $ELSE
    CALL UYTRRG(NF,N,MCL,$IX,$XN,$IC,$ICA,$CG,$CR,$CZ,$G,$GN,$S,UMAX&
,GMAX,IOLD,KTERM)
  $ENDIF
  $ADD(REAL,'\$XN($NF)\$CG($NF*$MCL)\$CR($NF*($NF+1)/2)&
  \$CZ($NF*$NF)\$G($NF)\$GN($NF)\$S($NF)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NF)')
$REM  $ADD(INTEGER,'\NF\N\MCL\IOLD\KTERM')
$REM  $ADD(REAL,'\UMAX\GMAX')
 $ADD(INIT)
    ITRAN=2
  $ENDADD
  $EXIT
