$REM +---------------------------------------------------------------+
$REM +  TEMPLATE: UZDCLP                                   01/12/98  +
$REM +                                                               +
$REM +  PURPOSE:  DRIVER FOR UFO CONTROL LANGUAGE PREPROCESSOR       +
$REM +---------------------------------------------------------------+

$REM +----+ INSTALATION +--------------------------------------------+

$OPTION(MODERW=3)
$OPTION(ILNLEN=200)
$OPTION(OLNLEN=200)
$OPTION(FN2='.I')
$P='D'
$USERUNIT=12
$OUTPUTUNIT=11
$FLOAT='REAL*8'
$DBLE='DBLE'
$GRAPHICS=0
$OPTION(DIALGR=.FALSE.)

$REM +----+ OUTPUT UNIT FOR ERROR MESSAGES +-------------------------+
$SET(ERROR)
$OPTION(OUNIT=6)
ERROR:
$ENDSET

$REM +----+ INITIATION +---------------------------------------------+

$OPTION(LSUBS=.FALSE.)


$REM +----+ INITIATION OF THE SYSTEM MACROVARIABLES +---------------+

$SET(BATCH)
  $OPTION(DIALOG=0)
  $OPTION(DIALGR=.FALSE.)
  $DIA=0
$ENDSET

$SET(GDIALOGUE)
  $OPTION(DIALOG=1)
  $OPTION(DIALGR=.FALSE.)
  $DIA=1
$ENDSET

$SET(TDIALOGUE)
  $OPTION(DIALOG=1)
  $OPTION(DIALGR=.FALSE.)
  $DIA=1
$ENDSET

$DIALOGUE=TDIALOGUE

$SET(STANDARD)
  $SUBST('UZSTAN')
$ENDSET

$SET(METHOD)
  $SUBST('UZMETH')
$ENDSET

$SET(TSTART)
  CALL UYTIM1(ITIME)
  $ADD(INTEGER,'\ITIME')
$ENDSET

$SET(TSTOP)
  CALL UYTIM2(ITIME)
$ENDSET

$NUMBERS='1\2\3\4\5\6\7\8\9\0'

$SET(VARERASE)
  CALL UYCLEA
$ENDSET

$SET(INITIATION)
  $SUBST('UZINIT')
$ENDSET

$SET(LABEL)
  $L CONTINUE
  $IF(TRACE='YES') $SUBST('UZTPNT')
$ENDSET

$INTERFACE='$REM'

$OPTION(MODERW=2)

$INTEGER='.END'
$INTEGER2='.END'
$REAL='.END'
$REAL4='.END'
$LOGICAL='.END'
$CHARACTER='.END'

$OPTION(MODERW=1)
$DIA=1

$SUBST('UZSETM')

$SET(MODERASE)
  $SUBST('UZMDER')
$ENDSET
$SET(METERASE)
  $SUBST('UZMTER')
$ENDSET
$SET(RUNERASE)
  $SUBST('UZMTER')
  $LMET=-1
$ENDSET

$SET(GLOBAL)
  $OPTION(LFORTO=.FALSE.)
  $$SUBST('UZDECL')
  $$SINIC
  $OPTION(LFORTO=.TRUE.)
  $ERASE(GLOBAL)
  $SET(UFOINPUT)
    $SUBST('UZINPT')
  $ENDSET
  $IF($DEF(DELETION))
    OPEN(7,FILE='P.PER',STATUS='REPLACE')
    CLOSE (7)
    $ERASE(DELETION)
  $ENDIF
$ENDSET

$REM $INPUT=' '

$SET(SUBROUTINES)

$ENDSET

$NEXT=0
$METHODINIT=.FALSE.
$OPTION(LSUBS=.TRUE.)

$REM +----+ 1. PASS +------------------------------------------------+

$TMPUNIT=$OUNIT
$INITUNIT=$IUNIT
$OPTION(IUNIT=USERUNIT)
$OPTION(LFORTO=.FALSE.)
$$SUBST('UZIPAR')
$$SUBROUTINES

$REM +----+ 2. PASS +------------------------------------------------+

$OPTION(LFORTO=.TRUE.)
$OPTION(OUNIT=OUTPUTUNIT)
$REWIND(TMPUNIT)
$OPTION(IUNIT=TMPUNIT)


